// BB8 Code by Jay Luna
// Make Course Project USF Spring 2016

#include <SoftwareSerial.h>
#include <I2Cdev.h>
#include <Wire.h>

// BlueTooth to App Communication
#define    STX          0x02
#define    ETX          0x03

SoftwareSerial mySerial(11,12); //TX, RX
byte cmd[8]; 

//motor control
//motor 1
#define enA 10
#define in1 9
#define in2 8
//motor 2
#define enB 5
#define in3 7
#define in4 6

int biasY, biasX, Xleft, Xright, joyY2;
int motor1Offset = 29, motor2Offset = 46;
int motor1Start = motor1Offset + 21, motor2Start = motor2Offset + 4;
int motor1PWM = 0, motor2PWM = 0;

void setup() {
  Serial.begin(57600);
    mySerial.begin(57600);  // 57600 = max value for softserial     
    while(mySerial.available())  mySerial.read(); // empty RX buffer
    pinMode(enA, OUTPUT);
    pinMode(enB, OUTPUT);
    pinMode(in1, OUTPUT);
    pinMode(in2, OUTPUT);
    pinMode(in3, OUTPUT);
    pinMode(in4, OUTPUT);

}

void loop() {
blueTooth();
motorControl();
}

void blueTooth(){
 if(mySerial.available())  {   // data received from smartphone
   delay(2);
   cmd[0] =  mySerial.read();  
   if(cmd[0] == STX)  {
     int i=1;      
     while(mySerial.available())  {
       delay(1);
       cmd[i] = mySerial.read();
       if(cmd[i]>127 || i>7)                 break;     // Communication error
       if((cmd[i]==ETX) && (i==2 || i==7))   break;     // Button or Joystick data
       i++;
     }
     if(i==7){
      getJoystickState(cmd);     // 6 Bytes  ex: < STX "200" "180" ETX >
     }
   }
 } 
}

void getJoystickState(byte data[8])    {
 int joyX = (data[1]-48)*100 + (data[2]-48)*10 + (data[3]-48);       // obtain the Int from the ASCII representation
 int joyY = (data[4]-48)*100 + (data[5]-48)*10 + (data[6]-48);
 joyX = joyX - 200;                                                  // Offset to avoid
 joyY = joyY - 200;                                                  // transmitting negative numbers

 if(joyX<-100 || joyX>100 || joyY<-100 || joyY>100)     return;      // commmunication error
 
// Your code here ...
//   Serial.print("Joystick position:  ");
//   Serial.print(joyX);  
//   Serial.print(", ");  
//   Serial.println(joyY);

  biasY = map(joyY, -100, 100, -255, 255);
  biasY = abs(biasY);
  joyY2 = joyY;
  Serial.println(biasY);
  
//  Xleft = map(joyX, -100, 0, 255, 0);
//  Xleft = constrain(Xleft, 0, 255);
//  
//  Xright = map(joyX, 0, 100, 0, 255);
//  Xright = constrain(Xright, 0, 255);

  //Serial.println(biasY);
//  Serial.println(Xleft);
//  Serial.println(Xright);

//  motor1PWM = abs(biasY);
//  motor1PWM = map(motor1PWM, 0, 255, motor1Start, 255);
//  motor1PWM = constrain(motor1PWM, 0, 255);
//
//  motor2PWM = abs(biasY);
//  motor2PWM = map(motor2PWM, 0, 255, motor2Start, 255);
//  motor2PWM = constrain(motor2PWM, 0, 255);
}

void motorControl(){
     //Serial.println(joyY);
  if (joyY2 > 0){
    //motor A
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
    //motor B
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);

    analogWrite(enA, biasY - Xleft);
    analogWrite(enB, biasY - Xright);
  }

  else if (joyY2 < 0) {
    //motor A
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
    //motor B
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);

    analogWrite(enA, biasY - Xleft);
    analogWrite(enB, biasY - Xright);
  }

  else {
    digitalWrite(in1, LOW);
    digitalWrite(in2, LOW);
    //motor B
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);

    analogWrite(enA, 0);
    analogWrite(enB, 0);
  }

  Serial.println(motor1PWM);
  Serial.println(motor2PWM);
}

